
Infrastructure - Task #1183

Story # 1388 (Closed): implement MN-MN replication manager in CN stack

Implement mechanism in CN that will execute a replication operation on a MN

2011-01-03 20:23 - Dave Vieglais

Status: Closed Start date: 2011-01-03

Priority: Normal Due date:  

Assignee: Chris Jones % Done: 100%

Category: d1_replication Estimated time: 0.00 hour

Target version: Sprint-2011.41-Block.5   

Milestone: CCI-0.7.0 Story Points:  

Product Version: *   

Description

Described in UC09 ( http://mule1.dataone.org/ArchitectureDocs-current/design/UseCases/09_uc.html ), this task is to implement a

mechanism on the CN that given a PID, a source MN PID and a target MN PID, will invoke replicate() on the target MN and update

the replica status in the system metadata for the object.

History

#1 - 2011-01-20 04:35 - Rob Nahf

code for issuing a replicate command (assembling the mime-multipart, doing the POST, etc. is in the DataReplicateTest.java class in d1_integration. 

It should probably move to d1_libclient_java, but hasn't been done yet.  It does not do all of the tasks needed for this story, but is a start.

#2 - 2011-03-01 18:40 - Robert Waltz

- Category set to d1_replication

- Assignee set to Rob Nahf

- Milestone set to CCI-0.5

#3 - 2011-03-16 17:49 - Robert Waltz

- Assignee changed from Rob Nahf to Robert Waltz

#4 - 2011-03-16 17:50 - Robert Waltz

- Parent task changed from #1132 to #1388

#5 - 2011-03-25 16:54 - Robert Waltz

- Milestone deleted (CCI-0.5)

#6 - 2011-08-16 17:17 - Robert Waltz

- Assignee changed from Robert Waltz to Chris Jones

- Milestone set to CCI-0.7.0

#7 - 2011-08-25 14:06 - Chris Jones

- Status changed from New to In Progress

Created the d1_replication project within the cn project that provides a ReplicationService class.  This class will coordinate replication by adding tasks

to a distributed replication queue and processing those tasks, calling replicate() on the target MN.  The class is stubbed out, functionality pending.

#8 - 2011-09-08 16:08 - Chris Jones

- Status changed from In Progress to Closed
The ReplicationService class creates ReplicationTask objects and queues them into a Hazelcast queue.  It then handles the items in the queue,

sending them to a cluster-wide ExecutorService.  The executor service calls the ReplicationTask.call() method, which intiates replication on the MN.
